searchNodes=[{"doc":"ZenMonitor provides efficient monitoring of remote processes and controlled dissemination of any resulting :DOWN messages. This module provides a convenient client interface which aims to be a drop in replacement for Process.monitor/1 and Process.demonitor/2 Known differences between ZenMonitor and Process ZenMonitor.demonitor/2 has the same signature as Process.demonitor/2 but does not respect the :info option. ZenMonitor aims to be efficient over distribution, one of the main strategies for achieving this is relying mainly on local monitors and then batching up all changes over a time period to be sent as a single message. This design means that additional latency is added to the delivery of down messages in pursuit of the goal. Where Process.monitor/1 on a remote process will provide a :DOWN message as soon as possible, ZenMonitor.monitor/1 on a remote process will actually have a number of batching periods to go through before the message arrives at the monitoring process, here are all the points that add latency. When the monitor is enqueued it has to wait until the next sweep happens in the ZenMonitor.Local.Connector until it will be delivered to the ZenMonitor.Proxy . The monitor arrives at the ZenMonitor.Proxy , the process crashes and the ERTS :DOWN message is delivered. This will be translated into a death_certificate and sent to a ZenMonitor.Proxy.Batcher for delivery. It will have to wait until the next sweep happens for it to be sent back to the ZenMonitor.Local.Connector for fan-out. The dead summary including the death_certificate arrives at the ZenMonitor.Local.Connector and a down_dispatch is created for it and enqueued with the ZenMonitor.Local . The down_dispatch waits in a queue until the ZenMonitor.Local.Dispatcher generates more demand. Once demand is generated, ZenMonitor.Local will hand off the down_dispatch for actual delivery by ZenMonitor.Local.Dispatcher . Steps 1 and 3 employ a strategy of batch sizing to prevent the message from growing too large. The batch size is controlled by application configuration and is alterable at boot and runtime. This means though that Steps 1 and 3 can be delayed by N intervals where N = ceil(items_ahead_of_event / chunk_size) Step 4 employs a similar batching strategy, a down_dispatch will wait in queue for up to N intervals where N = ceil(items_ahead_of_dispatch / chunk_size) ZenMonitor decorates the reason of the :DOWN message. If a remote process goes down because of original_reason , this will get decorated as {:zen_monitor, original_reason} when delivered by ZenMonitor. This allows the receiver to differentiate :DOWN messages originating from ZenMonitor.monitor/1 and those originating from Process.monitor/1 . This is necessary when operating in mixed mode. It is the responsibility of the receiver to unwrap this reason if it requires the original_reason for some additional handling of the :DOWN message.","ref":"ZenMonitor.html","title":"ZenMonitor","type":"module"},{"doc":"Delegate to ZenMonitor.Local.compatibility/1","ref":"ZenMonitor.html#compatibility/1","title":"ZenMonitor.compatibility/1","type":"function"},{"doc":"Delegate to ZenMonitor.Local.compatibility_for_node/1","ref":"ZenMonitor.html#compatibility_for_node/1","title":"ZenMonitor.compatibility_for_node/1","type":"function"},{"doc":"Delegate to ZenMonitor.Local.Connector.connect/1","ref":"ZenMonitor.html#connect/1","title":"ZenMonitor.connect/1","type":"function"},{"doc":"Delegate to ZenMonitor.Local.demonitor/2","ref":"ZenMonitor.html#demonitor/2","title":"ZenMonitor.demonitor/2","type":"function"},{"doc":"Find the node for a destination.","ref":"ZenMonitor.html#find_node/1","title":"ZenMonitor.find_node/1","type":"function"},{"doc":"Get the module to use for gen calls from the Application Environment This module only needs to support GenServer.call/3 and GenServer.cast/2 functionality, see ZenMonitor's @gen_module for the default value This can be controlled at boot and runtime with the {:zen_monitor, :gen_module} setting, see ZenMonitor.gen_module/1 for runtime convenience functionality.","ref":"ZenMonitor.html#gen_module/0","title":"ZenMonitor.gen_module/0","type":"function"},{"doc":"Put the module to use for gen calls into the Application Environment This is a simple convenience function for overwriting the {:zen_monitor, :gen_module} setting at runtime.","ref":"ZenMonitor.html#gen_module/1","title":"ZenMonitor.gen_module/1","type":"function"},{"doc":"Delegate to ZenMonitor.Local.monitor/1","ref":"ZenMonitor.html#monitor/1","title":"ZenMonitor.monitor/1","type":"function"},{"doc":"Get the current monotonic time in milliseconds This is a helper because System.monotonic_time(:milliseconds) is long and error-prone to type in multiple call sites. See System.monotonic_time/1 for more information.","ref":"ZenMonitor.html#now/0","title":"ZenMonitor.now/0","type":"function"},{"doc":"ZenMonitor.destination are all the types that can be monitored. pid() either local or remote {name, node} represents a named process on the given node name :: atom() is a named process on the local node","ref":"ZenMonitor.html#t:destination/0","title":"ZenMonitor.destination/0","type":"type"},{"doc":"ZenMonitor.Local Most of the actual logic of monitoring and fan-out is handled by ZenMonitor.Local.Connector , see that module for more information. ZenMonitor.Local is responsible for monitoring the subscribing local processes and cleaning up monitors if they crash.","ref":"ZenMonitor.Local.html","title":"ZenMonitor.Local","type":"module"},{"doc":"Synchronously checks the length of the ZenMonitor.Local's internal batch","ref":"ZenMonitor.Local.html#batch_length/0","title":"ZenMonitor.Local.batch_length/0","type":"function"},{"doc":"Check the compatiblity of the remote node that owns the provided destination This is a simple convenience function that looksup the node for the destination and then calls ZenMonitor.Local.compatiblity_for_node/1","ref":"ZenMonitor.Local.html#compatibility/1","title":"ZenMonitor.Local.compatibility/1","type":"function"},{"doc":"See ZenMonitor.Local.Connector.compatibility/1 .","ref":"ZenMonitor.Local.html#compatibility_for_node/1","title":"ZenMonitor.Local.compatibility_for_node/1","type":"function"},{"doc":"Stop monitoring a process by monitor reference Has the same semantics as Process.demonitor/2 (although you can pass the :info option, it has no effect and is not honored, :flush is honored) To demonitor a process you should pass in the reference returned from ZenMonitor.Local.monitor/1 for the given process","ref":"ZenMonitor.Local.html#demonitor/2","title":"ZenMonitor.Local.demonitor/2","type":"function"},{"doc":"Asynchronously enqueue a list of down dispatches for delivery by the Dispatcher If called with the empty list, cast will be suppressed.","ref":"ZenMonitor.Local.html#enqueue/1","title":"ZenMonitor.Local.enqueue/1","type":"function"},{"doc":"Callback implementation for GenStage.handle_call/3 .","ref":"ZenMonitor.Local.html#handle_call/3","title":"ZenMonitor.Local.handle_call/3","type":"function"},{"doc":"Callback implementation for GenStage.handle_cast/2 .","ref":"ZenMonitor.Local.html#handle_cast/2","title":"ZenMonitor.Local.handle_cast/2","type":"function"},{"doc":"Handles demand from ZenMonitor.Local.Dispatcher ZenMonitor.Local maintains a queue of pending messages to be sent to local processes, the actual dispatch of which are throttled by ZenMonitor.Local.Dispatcher. When ZenMonitor.Local.Dispatcher requests more messages to dispatch, this handler will collect up to the requested amount from the batch queue to satisfy the demand.","ref":"ZenMonitor.Local.html#handle_demand/2","title":"ZenMonitor.Local.handle_demand/2","type":"function"},{"doc":"Callback implementation for GenStage.handle_info/2 .","ref":"ZenMonitor.Local.html#handle_info/2","title":"ZenMonitor.Local.handle_info/2","type":"function"},{"doc":"Gets the hibernation threshold from the Application Environment Every time the demand empties the queue a counter is incremented. When this counter exceeds the hibernation threshold the ZenMonitor.Local process will be sent into hibernation. See ZenMonitor.Local's @hibernation_threshold for the default value This can be controlled at boot and runtime with the {:zen_monitor, :hibernation_threshold} setting, see ZenMonitor.Local.hibernation_threshold/1 for runtime convenience functionality.","ref":"ZenMonitor.Local.html#hibernation_threshold/0","title":"ZenMonitor.Local.hibernation_threshold/0","type":"function"},{"doc":"Puts the hibernation threshold into the Application Environment This is a simple convenience function for overwriting the {:zen_monitor, :hibernation_threshold} setting at runtime.","ref":"ZenMonitor.Local.html#hibernation_threshold/1","title":"ZenMonitor.Local.hibernation_threshold/1","type":"function"},{"doc":"Callback implementation for GenStage.init/1 .","ref":"ZenMonitor.Local.html#init/1","title":"ZenMonitor.Local.init/1","type":"function"},{"doc":"Begin monitoring the given process Has the same semantics as Process.monitor/1 , DOWN messages will be delivered at a pace controlled by the :zen_monitor, :demand_interval and :zen_monitor, :demand_amount environment variables","ref":"ZenMonitor.Local.html#monitor/1","title":"ZenMonitor.Local.monitor/1","type":"function"},{"doc":"","ref":"ZenMonitor.Local.html#start_link/1","title":"ZenMonitor.Local.start_link/1","type":"function"},{"doc":"Effective compatibility of a remote node","ref":"ZenMonitor.Local.html#t:compatibility/0","title":"ZenMonitor.Local.compatibility/0","type":"type"},{"doc":"Represents a future down dispatch for a given pid to be delivered by ZenMonitor.Local.Dispatcher","ref":"ZenMonitor.Local.html#t:down_dispatch/0","title":"ZenMonitor.Local.down_dispatch/0","type":"type"},{"doc":"ZenMonitor.Local.Connector performs a variety of duties. For every remote that a the local is interested in monitoring processes on there will be a dedicated ZenMonitor.Local.Connector . This collection of Connectors are managed by a GenRegistry registered under the ZenMonitor.Local.Connector atom. Connecting and Monitoring the remote ZenMonitor.Proxy Connectors, as their name suggests, connect to the ZenMonitor.Proxy on the remote node that they are responsible for. They do this using standard ERTS Distribution, by invoking the remote Proxy's ping command. A Remote is considered compatible if the ping command returns the :pong atom, otherwise it will be marked incompatible. Connectors manage their remote node's status in the global node status cache, and provide facilities for efficient querying of remote status, see compatibility/1 and cached_compatibility/1 Batching and Updating the remote ZenMonitor.Proxy When a local process wishes to monitor a remote process, the Connector will be informed of this fact with a call to monitor/3 . The Connector is responsible for maintaining a local record of this monitor for future fan-out and for efficiently batching up these requests to be delivered to the remote ZenMonitor.Proxy. Fan-out of Dead Summaries Periodically, the ZenMonitor.Proxy (technically the ZenMonitor.Proxy.Batcher ) on the remote node will send a &quot;Dead Summary&quot;. This is a message from the remote that informs the Connector of all the processes the Connector has monitored that have gone down since the last summary. The Connector uses it's local records to generate a batch of down dispatches . These are messages that look identical to the messages provided by Process.monitor/1 when a process goes down. It is sometimes necessary for the original monitoring process to be able to discern whether the :DOWN message originated from ERTS or from ZenMonitor, to aid this, ZenMonitor will wrap the original reason in a tuple of {:zen_monitor, original_reason} . The fan-out messages are sent to ZenMonitor.Local for eventual delivery via ZenMonitor.Local.Dispatcher , see those modules for more information. Fan-out of nodedown / ZenMonitor.Proxy down The Connector is also responsible for monitoring the remote node and dealing with nodedown (or the node becoming incompatible, either due to the ZenMonitor.Proxy crashing or a code change). If the Connector detects that the remote it is responsible for is down or no longer compatible, it will fire every established monitor with {:zen_monitor, :nodedown} . It uses the same mechanism as for Dead Summaries, see ZenMonitor.Local and ZenMonitor.Local.Dispatcher for more information.","ref":"ZenMonitor.Local.Connector.html","title":"ZenMonitor.Local.Connector","type":"module"},{"doc":"Check the cached compatibility status for a remote node This will only perform a fast client-side lookup in the ETS table. If an authoritative entry is found it will be returned (either :compatible , :incompatible , or :unavailable ). If no entry is found then :miss is returned. If an expired entry is found then {:expired, attempts} is returned.","ref":"ZenMonitor.Local.Connector.html#cached_compatibility/1","title":"ZenMonitor.Local.Connector.cached_compatibility/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ZenMonitor.Local.Connector.html#child_spec/1","title":"ZenMonitor.Local.Connector.child_spec/1","type":"function"},{"doc":"Gets the chunk size from the Application Environment The chunk size is the maximum number of subscriptions that will be sent during each sweep, see ZenMonitor.Local.Connector's @chunk_size for the default value This can be controlled at boot and runtime with the {:zen_monitor, :connector_chunk_size} setting, see ZenMonitor.Local.Connector.chunk_size/1 for runtime convenience functionality.","ref":"ZenMonitor.Local.Connector.html#chunk_size/0","title":"ZenMonitor.Local.Connector.chunk_size/0","type":"function"},{"doc":"Puts the chunk size into the Application Environment This is a simple convenience function for overwriting the {:zen_monitor, :connector_chunk_size} setting at runtime.","ref":"ZenMonitor.Local.Connector.html#chunk_size/1","title":"ZenMonitor.Local.Connector.chunk_size/1","type":"function"},{"doc":"Determine the effective compatibility of a remote node This will attempt a fast client-side lookup in the ETS table. Only a positive :compatible record will result in :compatible , otherwise the effective compatibility is :incompatible","ref":"ZenMonitor.Local.Connector.html#compatibility/1","title":"ZenMonitor.Local.Connector.compatibility/1","type":"function"},{"doc":"Connect to the provided remote This function will not consult the cache before calling into the GenServer, the GenServer will consult with the cache before attempting to connect, this allows for many callers to connect with the server guaranteeing that only one attempt will actually perform network work. If the compatibility of a remote host is needed instead, callers should use the compatibility/1 or cached_compatibility/1 functions. compatibility/1 will provide the effective compatibility, cached_compatibility/1 is mainly used internally but can provide more detailed information about the cache status of the remote. Neither of these methods, compatibility/1 nor cached_compatibility/1 , will perform network work or call into the GenServer.","ref":"ZenMonitor.Local.Connector.html#connect/1","title":"ZenMonitor.Local.Connector.connect/1","type":"function"},{"doc":"Asynchronously demonitors a pid.","ref":"ZenMonitor.Local.Connector.html#demonitor/2","title":"ZenMonitor.Local.Connector.demonitor/2","type":"function"},{"doc":"Get a connector from the registry by destination","ref":"ZenMonitor.Local.Connector.html#get/1","title":"ZenMonitor.Local.Connector.get/1","type":"function"},{"doc":"Get a connector from the registry by remote node","ref":"ZenMonitor.Local.Connector.html#get_for_node/1","title":"ZenMonitor.Local.Connector.get_for_node/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"ZenMonitor.Local.Connector.html#init/1","title":"ZenMonitor.Local.Connector.init/1","type":"function"},{"doc":"Asynchronously monitors a pid.","ref":"ZenMonitor.Local.Connector.html#monitor/3","title":"ZenMonitor.Local.Connector.monitor/3","type":"function"},{"doc":"Retrieves all the monitors established between the target and the subscriber","ref":"ZenMonitor.Local.Connector.html#monitors/2","title":"ZenMonitor.Local.Connector.monitors/2","type":"function"},{"doc":"","ref":"ZenMonitor.Local.Connector.html#start_link/1","title":"ZenMonitor.Local.Connector.start_link/1","type":"function"},{"doc":"Gets the sweep interval from the Application Environment The sweep interval is the number of milliseconds to wait between sweeps, see ZenMonitor.Local.Connector's @sweep_interval for the default value This can be controlled at boot and runtime with the {:zen_monitor, :connector_sweep_interval} setting, see ZenMonitor.Local.Connector.sweep_interval/1 for runtime convenience functionality.","ref":"ZenMonitor.Local.Connector.html#sweep_interval/0","title":"ZenMonitor.Local.Connector.sweep_interval/0","type":"function"},{"doc":"Puts the sweep interval into the Application Environment This is a simple convenience function for overwriting the {:zen_monitor, :connector_sweep_interval} setting at runtime.","ref":"ZenMonitor.Local.Connector.html#sweep_interval/1","title":"ZenMonitor.Local.Connector.sweep_interval/1","type":"function"},{"doc":"","ref":"ZenMonitor.Local.Connector.html#t:cached_compatibility/0","title":"ZenMonitor.Local.Connector.cached_compatibility/0","type":"type"},{"doc":"","ref":"ZenMonitor.Local.Connector.html#t:compatibility/0","title":"ZenMonitor.Local.Connector.compatibility/0","type":"type"},{"doc":"","ref":"ZenMonitor.Local.Connector.html#t:death_certificate/0","title":"ZenMonitor.Local.Connector.death_certificate/0","type":"type"},{"doc":"","ref":"ZenMonitor.Local.Connector.html#t:down_dispatch/0","title":"ZenMonitor.Local.Connector.down_dispatch/0","type":"type"},{"doc":"","ref":"ZenMonitor.Local.Connector.html#t:t/0","title":"ZenMonitor.Local.Connector.t/0","type":"type"},{"doc":"Maintains the internal state for the Connector monitors is an ETS table for keeping track of monitors for the purpose of fan-out. remote_node_monitored is a flag used to track whether or not the remote node has been monitored remote_proxy_ref is the monitoring reference of the remote node's ZenMonitor.Proxy remote is the remote node for which the Connector is responsible. batch is the queue of instructions pending until the next sweep. length is the current length of the batch queue (calculating queue length is an O(n) operation, it is simple to track it as elements are added / removed)","ref":"ZenMonitor.Local.Connector.State.html","title":"ZenMonitor.Local.Connector.State","type":"module"},{"doc":"","ref":"ZenMonitor.Local.Connector.State.html#t:t/0","title":"ZenMonitor.Local.Connector.State.t/0","type":"type"},{"doc":"ZenMonitor.Local.Dispatcher is a GenStage Consumer responsible for throttled delivery of down messages. ZenMonitor.Local acts as a GenStage Producer, it stores all of the down messages that need to be dispatched based off of what has been enqueued by the ZenMonitor.Local.Connector . The Dispatcher will deliver these messages throttled by a maximum rate which is controlled by the {:zen_monitor, :demand_interval} and {:zen_monitor, :demand_amount} settings. To calculate the maximum number of messages processed per second you can use the following formula: maximum_mps = (demand_amount) * (1000 / demand_interval) For example, if the demand_amount is 1000, and demand_interval is 100 (milliseconds) the maximum messages per second are: maximum_mps = (1000) * (1000 / 100) -&gt; ( 1000 ) * 10 -&gt; 10_000 For convenience a ZenMonitor.Local.Dispatcher.maximum_mps/0 is provided that will perform this calculation.","ref":"ZenMonitor.Local.Dispatcher.html","title":"ZenMonitor.Local.Dispatcher","type":"module"},{"doc":"Gets the demand amount from the Application Environment The demand amount is the number of events tor request from the GenStage Producer ( ZenMonitor.Local ) every demand interval This can be controlled at boot and runtime with the {:zen_monitor, :demand_amount} setting, see ZenMonitor.Local.Dispatcher.demand_amount/1 for runtime convenience functionality.","ref":"ZenMonitor.Local.Dispatcher.html#demand_amount/0","title":"ZenMonitor.Local.Dispatcher.demand_amount/0","type":"function"},{"doc":"Puts the demand amount into the Application Environment This is a simple convenience function for overwriting the {:zen_monitor, :demand_amount} setting at runtime.","ref":"ZenMonitor.Local.Dispatcher.html#demand_amount/1","title":"ZenMonitor.Local.Dispatcher.demand_amount/1","type":"function"},{"doc":"Gets the demand interval from the Application Environment The demand interval is the number of milliseconds to wait between demanding more events from the GenStage Producer ( ZenMonitor.Local ) This can be controlled at boot and runtime with the {:zen_monitor, :demand_interval} setting, see ZenMonitor.Local.Dispatcher.demand_interval/1 for runtime convenience functionality.","ref":"ZenMonitor.Local.Dispatcher.html#demand_interval/0","title":"ZenMonitor.Local.Dispatcher.demand_interval/0","type":"function"},{"doc":"Puts the demand interval into the Application Environment This is a simple convenience function for overwrite the {:zen_monitor, :demand_interval} setting at runtime","ref":"ZenMonitor.Local.Dispatcher.html#demand_interval/1","title":"ZenMonitor.Local.Dispatcher.demand_interval/1","type":"function"},{"doc":"Handles the events for dispatch Dispatch is a simple two step procedure followed for each message to be dispatched. Check if the message is still valid. Messages can become invalid if the monitor was demonitored after the message was enqueued. 2a. If valid: forward the message to the subscriber 2b. If invalid: skip message Event dispatch will calculate an &quot;unfulfilled&quot; demand based off the number of messages skipped and demand that the producer provide additional events so that MPS is maintained and prevent the Dispatcher from being starved because of invalid messages.","ref":"ZenMonitor.Local.Dispatcher.html#handle_events/3","title":"ZenMonitor.Local.Dispatcher.handle_events/3","type":"function"},{"doc":"Handles the periodic generate_demand message Asks the producer for demand_amount of events then schedules the next demand generation.","ref":"ZenMonitor.Local.Dispatcher.html#handle_info/2","title":"ZenMonitor.Local.Dispatcher.handle_info/2","type":"function"},{"doc":"Handles the callback for the subscription being established with the producer. This is the start of the demand loop, once the producer confirms subscription, the initial call to schedule_demand/0 happens.","ref":"ZenMonitor.Local.Dispatcher.html#handle_subscribe/4","title":"ZenMonitor.Local.Dispatcher.handle_subscribe/4","type":"function"},{"doc":"Callback implementation for GenStage.init/1 .","ref":"ZenMonitor.Local.Dispatcher.html#init/1","title":"ZenMonitor.Local.Dispatcher.init/1","type":"function"},{"doc":"Calculate the current maximum messages per second This is a convenience function to help operators understand the current throughput of the Dispatcher.","ref":"ZenMonitor.Local.Dispatcher.html#maximum_mps/0","title":"ZenMonitor.Local.Dispatcher.maximum_mps/0","type":"function"},{"doc":"","ref":"ZenMonitor.Local.Dispatcher.html#start_link/1","title":"ZenMonitor.Local.Dispatcher.start_link/1","type":"function"},{"doc":"Maintains the internal state for ZenMonitor.Local subscribers is an ETS table that tracks local subscribers to prevent multiple monitors batch is the queue of messages awaiting delivery to ZenMonitor.Local.Dispatcher length is the current length of the batch queue (calculating queue length is an O(n) operation, it is simple to track it as elements are added / removed) queue_emptied is the number of times the queue has been emptied. Once this number exceeds the hibernation_threshold (see hibernation_threshold/0 ) the process will hibernate","ref":"ZenMonitor.Local.State.html","title":"ZenMonitor.Local.State","type":"module"},{"doc":"","ref":"ZenMonitor.Local.State.html#t:t/0","title":"ZenMonitor.Local.State.t/0","type":"type"},{"doc":"ZenMonitor.Local.Tables owns tables that are shared between multiple ZenMonitor.Local components. See nodes/0 and references/0 for more information.","ref":"ZenMonitor.Local.Tables.html","title":"ZenMonitor.Local.Tables","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ZenMonitor.Local.Tables.html#child_spec/1","title":"ZenMonitor.Local.Tables.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"ZenMonitor.Local.Tables.html#init/1","title":"ZenMonitor.Local.Tables.init/1","type":"function"},{"doc":"Nodes holds cached information about remote node compatibility This information is stored in one of the following structures: For compatible nodes { remote_node, :compatible } ^---key---^ ^--value--^ For incompatible nodes { remote_node, {:incompatible, enforce_until, attempts} } ^---key---^ ^---------------value-----------------^ enforce_until is the time (as reported by System.monotonic_time(:milliseconds)) after which this cache entry should no longer be enforced. attempts is the number of consecutive connect attempts that have failed, this value is useful for calculating geometric backoff values","ref":"ZenMonitor.Local.Tables.html#nodes/0","title":"ZenMonitor.Local.Tables.nodes/0","type":"function"},{"doc":"References holds the set of authoritative monitor references These references are stored in this structure: { {subscriber_pid, monitor_reference}, {remote_node, remote_pid} } ^-------------key-----------------^ ^----------value--------^ There is a compound key of {subscriber_pid, monitor_reference} this allows for lookup of a given reference (if the subscriber is known, by convention it will be the calling process, self()) or the retrieval of all active monitors for a subscriber.","ref":"ZenMonitor.Local.Tables.html#references/0","title":"ZenMonitor.Local.Tables.references/0","type":"function"},{"doc":"","ref":"ZenMonitor.Local.Tables.html#start_link/1","title":"ZenMonitor.Local.Tables.start_link/1","type":"function"},{"doc":"ZenMonitor.Proxy monitors local processes and proxies their down messages to interested ZenMonitor.Locals on remote nodes for fanout.","ref":"ZenMonitor.Proxy.html","title":"ZenMonitor.Proxy","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ZenMonitor.Proxy.html#child_spec/1","title":"ZenMonitor.Proxy.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"ZenMonitor.Proxy.html#init/1","title":"ZenMonitor.Proxy.init/1","type":"function"},{"doc":"Ping is a diagnostic function to check that the proxy is running. It is mainly used by ZenMonitor.Local.Connectors to check if ZenMonitor.Proxy is available and running on a remote node","ref":"ZenMonitor.Proxy.html#ping/0","title":"ZenMonitor.Proxy.ping/0","type":"function"},{"doc":"","ref":"ZenMonitor.Proxy.html#start_link/1","title":"ZenMonitor.Proxy.start_link/1","type":"function"},{"doc":"An instruction is a valid operation upon a given destination","ref":"ZenMonitor.Proxy.html#t:instruction/0","title":"ZenMonitor.Proxy.instruction/0","type":"type"},{"doc":"Defines the valid operations that can be processed","ref":"ZenMonitor.Proxy.html#t:operation/0","title":"ZenMonitor.Proxy.operation/0","type":"type"},{"doc":"A string of instructions with the same operation can be collapsed into a partition for more efficient processing.","ref":"ZenMonitor.Proxy.html#t:partition/0","title":"ZenMonitor.Proxy.partition/0","type":"type"},{"doc":"ZenMonitor.Proxy.Batcher is responsible for collecting death_certificates from ZenMonitor.Proxy destined for the Batcher's subscriber (normally the subscriber is a ZenMonitor.Local.Connector ) Periodically it will sweep and send all of the death_certificates it has collected since the last sweep to the subscriber for processing.","ref":"ZenMonitor.Proxy.Batcher.html","title":"ZenMonitor.Proxy.Batcher","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ZenMonitor.Proxy.Batcher.html#child_spec/1","title":"ZenMonitor.Proxy.Batcher.child_spec/1","type":"function"},{"doc":"Gets the chunk size from the Application Environment The chunk size is the maximum number of death certificates that will be sent during each sweep, see ZenMonitor.Proxy.Batcher's @chunk_size for the default value This can be controlled at boot and runtime with the {:zen_monitor, :batcher_chunk_size} setting, see ZenMonitor.Proxy.Batcher.chunk_size/1 for runtime convenience functionality.","ref":"ZenMonitor.Proxy.Batcher.html#chunk_size/0","title":"ZenMonitor.Proxy.Batcher.chunk_size/0","type":"function"},{"doc":"Puts the chunk size into the Application Environment This is a simple convenience function for overwrite the {:zen_monitor, :batcher_chunk_size} setting at runtime.","ref":"ZenMonitor.Proxy.Batcher.html#chunk_size/1","title":"ZenMonitor.Proxy.Batcher.chunk_size/1","type":"function"},{"doc":"Enqueues a new death certificate into the batcher","ref":"ZenMonitor.Proxy.Batcher.html#enqueue/3","title":"ZenMonitor.Proxy.Batcher.enqueue/3","type":"function"},{"doc":"Get a batcher for a given subscriber","ref":"ZenMonitor.Proxy.Batcher.html#get/1","title":"ZenMonitor.Proxy.Batcher.get/1","type":"function"},{"doc":"Handle enqueuing a new death_certificate Simply puts it in the batch queue.","ref":"ZenMonitor.Proxy.Batcher.html#handle_cast/2","title":"ZenMonitor.Proxy.Batcher.handle_cast/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"ZenMonitor.Proxy.Batcher.html#init/1","title":"ZenMonitor.Proxy.Batcher.init/1","type":"function"},{"doc":"","ref":"ZenMonitor.Proxy.Batcher.html#start_link/1","title":"ZenMonitor.Proxy.Batcher.start_link/1","type":"function"},{"doc":"Gets the sweep interval from the Application Environment The sweep interval is the number of milliseconds to wait between sweeps, see ZenMonitor.Proxy.Batcher's @sweep_interval for the default value This can be controlled at boot and runtime with the {:zen_monitor, :batcher_sweep_interval} setting, see ZenMonitor.Proxy.Batcher.sweep_interval/1 for runtime convenience functionality.","ref":"ZenMonitor.Proxy.Batcher.html#sweep_interval/0","title":"ZenMonitor.Proxy.Batcher.sweep_interval/0","type":"function"},{"doc":"Puts the sweep interval into the Application Environment This is a simple convenience function for overwrite the {:zen_monitor, :batcher_sweep_interval} setting at runtime","ref":"ZenMonitor.Proxy.Batcher.html#sweep_interval/1","title":"ZenMonitor.Proxy.Batcher.sweep_interval/1","type":"function"},{"doc":"Maintains the internal state for the Batcher subscriber is the process that death_certificates should be delivered to batch is the queue of death_certificates pending until the next sweep. length is the current length of the batch queue (calculating queue length is an O(n) operation, is is simple to track it as elements are added / removed)","ref":"ZenMonitor.Proxy.Batcher.State.html","title":"ZenMonitor.Proxy.Batcher.State","type":"module"},{"doc":"","ref":"ZenMonitor.Proxy.Batcher.State.html#t:t/0","title":"ZenMonitor.Proxy.Batcher.State.t/0","type":"type"},{"doc":"Maintains the internal state for ZenMonitor.Proxy monitors is an ETS table with all the pids that the Proxy is currently monitoring","ref":"ZenMonitor.Proxy.State.html","title":"ZenMonitor.Proxy.State","type":"module"},{"doc":"","ref":"ZenMonitor.Proxy.State.html#t:t/0","title":"ZenMonitor.Proxy.State.t/0","type":"type"},{"doc":"ZenMonitor.Proxy.Tables owns the tables that are shared between multiple ZenMonitor.Proxy components. See subscribers/0 for more information.","ref":"ZenMonitor.Proxy.Tables.html","title":"ZenMonitor.Proxy.Tables","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ZenMonitor.Proxy.Tables.html#child_spec/1","title":"ZenMonitor.Proxy.Tables.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"ZenMonitor.Proxy.Tables.html#init/1","title":"ZenMonitor.Proxy.Tables.init/1","type":"function"},{"doc":"","ref":"ZenMonitor.Proxy.Tables.html#start_link/1","title":"ZenMonitor.Proxy.Tables.start_link/1","type":"function"},{"doc":"Subscribers holds information about who is subscribed to each pid. This information is stored in the following structure: { { monitored_pid, subscriber } } ^-----------key-------------^ monitored_pid is the local process that is being monitored. subscriber is the remote ZenMonitor.Local.Connector that is interested in the monitored_pid","ref":"ZenMonitor.Proxy.Tables.html#subscribers/0","title":"ZenMonitor.Proxy.Tables.subscribers/0","type":"function"},{"doc":"OTP Application that acts as the entry point for ZenMonitor. This Application will start all necessary processes for a node to be a compatible ZenMonitor node and to communicate with other compatible ZenMonitor nodes. See ZenMonitor.Supervisor for more information.","ref":"ZenMonitor.Application.html","title":"ZenMonitor.Application","type":"module"},{"doc":"Callback implementation for Application.start/2 .","ref":"ZenMonitor.Application.html#start/2","title":"ZenMonitor.Application.start/2","type":"function"},{"doc":"Supervisor for the ZenMonitor.Local components. See ZenMonitor.Local , ZenMonitor.Local.Tables , ZenMonitor.Local.Connector , and ZenMonitor.Local.Dispatcher for more information about the supervised processes. There are many ZenMonitor.Local.Connector processes, which are managed by a GenRegistry . These are keyed by the remote node the Connector is responsible for. This supervisor uses the :rest_for_one strategy, so the order of the children is important and should not be altered.","ref":"ZenMonitor.Local.Supervisor.html","title":"ZenMonitor.Local.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ZenMonitor.Local.Supervisor.html#child_spec/1","title":"ZenMonitor.Local.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1 .","ref":"ZenMonitor.Local.Supervisor.html#init/1","title":"ZenMonitor.Local.Supervisor.init/1","type":"function"},{"doc":"","ref":"ZenMonitor.Local.Supervisor.html#start_link/1","title":"ZenMonitor.Local.Supervisor.start_link/1","type":"function"},{"doc":"Metrics helper for monitoring the ZenMonitor system.","ref":"ZenMonitor.Metrics.html","title":"ZenMonitor.Metrics","type":"module"},{"doc":"Given a pid or a registered name, this will return the message_queue_len as reported by Process.info/2","ref":"ZenMonitor.Metrics.html#message_queue_len/1","title":"ZenMonitor.Metrics.message_queue_len/1","type":"function"},{"doc":"Registers various probes for the ZenMonitor System. ERTS message_queue_len for the ZenMonitor.Local and ZenMonitor.Proxy processes. Internal Batch Queue length for ZenMonitor.Local (dispatches to be delivered) ETS table size for References (number of monitors) ETS table size for Subscribers (number of monitored local processes * interested remotes)","ref":"ZenMonitor.Metrics.html#register/0","title":"ZenMonitor.Metrics.register/0","type":"function"},{"doc":"Given a table identifier, returns the size as reported by :ets.info/2","ref":"ZenMonitor.Metrics.html#table_size/1","title":"ZenMonitor.Metrics.table_size/1","type":"function"},{"doc":"Supervisor for the ZenMonitor.Proxy components. See ZenMonitor.Proxy , ZenMonitor.Proxy.Tables , and ZenMonitor.Proxy.Batcher for more information about the supervised processes. There are many ZenMonitor.Proxy.Batcher processes, which are managed by a GenRegistry . These are keyed by the pid of the ZenMonitor.Local.Connector the Batcher is responsible for. This supervisor uses the :rest_for_one strategy, so the order of the children is important and should not be altered.","ref":"ZenMonitor.Proxy.Supervisor.html","title":"ZenMonitor.Proxy.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ZenMonitor.Proxy.Supervisor.html#child_spec/1","title":"ZenMonitor.Proxy.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1 .","ref":"ZenMonitor.Proxy.Supervisor.html#init/1","title":"ZenMonitor.Proxy.Supervisor.init/1","type":"function"},{"doc":"","ref":"ZenMonitor.Proxy.Supervisor.html#start_link/1","title":"ZenMonitor.Proxy.Supervisor.start_link/1","type":"function"},{"doc":"ZenMonitor.Supervisor is a convenience Supervisor that starts the Local and Proxy Supervisors See ZenMonitor.Local.Supervisor and ZenMonitor.Proxy.Supervisor for more information.","ref":"ZenMonitor.Supervisor.html","title":"ZenMonitor.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ZenMonitor.Supervisor.html#child_spec/1","title":"ZenMonitor.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1 .","ref":"ZenMonitor.Supervisor.html#init/1","title":"ZenMonitor.Supervisor.init/1","type":"function"},{"doc":"","ref":"ZenMonitor.Supervisor.html#start_link/1","title":"ZenMonitor.Supervisor.start_link/1","type":"function"},{"doc":"ZenMonitor.Truncator is used to truncate error messages to prevent error expansion issues. Error Expansion At the core of ZenMonitor is a system that collects local :DOWN messages, batches them up and relays them in bulk. This opens up a failure mode where each :DOWN message individually is deliverable, but the bulk summary grows to an unsupportable size due to the aggregation of large reason payloads. If no truncation is performed then the payload can cause instability on the sender or the receiver side. Truncation Behavior ZenMonitor will truncate error reasons if they exceed a certain size to prevent Error Expansion from breaking either the sender or the receiver. Truncation is performed recursively on the term up to a maximum depth which can be provided to the ZenMonitor.Truncator.truncate/2 function. See below for an explanation of how the Truncator treats different values Pass-Through Values There are a number of types that the Truncator will pass through unmodified. Atoms Pids Numbers References Ports Binaries less than @max_binary_size (see the Binary section below for more information) Binaries There is a configurable value @max_binary_size any binary encountered over this size will be truncated to @max_binary_size - 3 and a trailing '...' will be appended to indicate the value has been truncated. This guarantees that no binary will appear in the term with size greater than @max_binary_size Tuples 0-tuples through 4-tuples will be passed through with their interior terms recursively truncated. If a tuple has more than 4 elements, it will be replaced with the :truncated atom. Lists Lists with 0 to 4 elements will be passed through with each element recursively truncated. If a list has more than 4 elements, it will be replaced with the :truncated atom. Maps Maps with a map_size/1 less than 5 will be passed through with each value recursively truncated. If a map has a size of 5 or greater then it will be replaced with the :truncated atom. Structs Structs are converted into maps and then the map rules are applied, they are then converted back into structs. The effect is that a Struct with 4 fields or fewer will be retained (with all values recursively truncated) while Structs with 5 or more fields will be replaced with the :truncated atom. Recursion Limit The Truncator will only descend up to the depth argument passed into ZenMonitor.Truncator.truncate/2 , regardless of the value, if the recursion descends deeper than this value then the :truncated atom will be used in place of the original value. Configuration ZenMonitor.Truncator exposes two different configuration options, and allows for one call-site override. The configuration options are evaluated at compile time, changing these values at run-time (through a facility like Application.put_env/3 ) will have no effect. Both configuration options reside under the :zen_monitor app key. :max_binary_size is size in bytes over which the Truncator will truncate the binary. The largest binary returned by the Truncator is defined to be the max_binary_size + 3, this is because when the truncator Truncator a binary it will append ... to indicate that truncation has occurred. :truncation_depth is the default depth that the Truncator will recursively descend into the term to be truncated. This is the value used for ZenMonitor.Truncator.truncate/2 if no second argument is provided, providing a call-site second argument will override this configuration.","ref":"ZenMonitor.Truncator.html","title":"ZenMonitor.Truncator","type":"module"},{"doc":"Truncates a term to a given depth See the module documentation for more information about how truncation works.","ref":"ZenMonitor.Truncator.html#truncate/2","title":"ZenMonitor.Truncator.truncate/2","type":"function"},{"doc":"ZenMonitor allows for the efficient monitoring of remote processes with minimal use of ERTS Distribution.","ref":"readme.html","title":"ZenMonitor","type":"extras"},{"doc":"Add ZenMonitor to your dependencies def deps do [ { :zen_monitor , &quot;~&gt; 1.1&quot; } ] end","ref":"readme.html#installation","title":"ZenMonitor - Installation","type":"extras"},{"doc":"ZenMonitor strives to be a drop-in replacement for Process.monitor/1 . To those ends, the programming interface and all the complexities of how it carries out its task are simplified by a simple unified programming interface. All the functions that the caller needs to use have convenient delegates available in the top-level ZenMonitor module. The interface is detailed below. ZenMonitor.monitor/1 This is a drop-in replacement for Process.monitor/1 when it comes to processes. It is compatible with the various ways that Process.monitor/1 can establish monitors and will accept one of a pid , a name which is the atom that a local process is registered under, or a tuple of {name, node} for a registered process on a remote node. These are defined as the ZenMonitor.destination type. ZenMonitor.monitor/1 returns a standard reference that can be used to demonitor and can be matched against the reference provided in the :DOWN message. Similar to Process.monitor/1 , the caller is allowed to monitor the same process multiple times, each monitor will be provided with a unique reference and all monitors will fire :DOWN messages when the monitored process goes down. Even though the caller can establish multiple monitors, ZenMonitor is designed to handle this efficiently, the only cost is an additional ETS row on the local node and additional processing time at fan-out. ZenMonitor.demonitor/2 This is a mostly drop-in replacement for Process.demonitor/2 when it comes to processes. The first argument is the reference returned by ZenMonitor.monitor/1 . It accepts a list of option atoms, but only honors the :flush option at this time. Passing the :info option is allowed but has no effect, this function always returns true . ZenMonitor.compatibility/1 When operating in a mixed environment where some nodes are ZenMonitor compatible and some are not, it may be necessary to check the compatibility of a remote node. ZenMonitor.compatibility/1 accepts any ZenMonitor.destination and will report back one of :compatible or :incompatible for the remote's cached compatibility status. All remotes start off as :incompatible until a positively acknowledged connection is established. See the ZenMonitor.connect/1 function for more information on connecting nodes. ZenMonitor.compatibility_for_node/1 Performs the same operation as ZenMonitor.compatibility/1 but it accepts a node atom instead of a ZenMonitor.destination . ZenMonitor.connect/1 Attempts a positive connection with the provided remote node. Connections are established by using the @gen_module 's call/4 method to send a :ping message to the process registered under the atom ZenMonitor.Proxy on the remote. If this process responds with a :pong atom then the connection is positively established and the node is marked as :compatible . Any other response or error condition (timeout / noproc / etc) will be considered negative acknowledgement. ZenMonitor.connect/1 is actually a delegate for ZenMonitor.Local.Connector.connect/1 see the documentation there for more information about how connect behaves. Handling Down Messages Any :DOWN message receivers (most commonly GenServer.handle_info/2 callbacks) that match on the reason should be updated to include an outer {:zen_monitor, original_match} wrapper. def handle_info ( { :DOWN , ref , :process , pid , :specific_reason } , state ) do ... end Should be updated to the following. def handle_info ( { :DOWN , ref , :process , pid , { :zen_monitor , :specific_reason } } , state ) do ... end","ref":"readme.html#using-zenmonitor","title":"ZenMonitor - Using ZenMonitor","type":"extras"},{"doc":"ZenMonitor was developed at Discord to improve the stability of our real-time communications infrastructure. ZenMonitor improves stability in a couple of different ways. Traffic Calming When a process is being monitored by a large number of remote processes, that process going down can cause both the node hosting the downed process and the node hosting the monitoring processes to be suddenly flooded with an large amount of work. This is commonly referred to as a thundering herd and can overwhelm either node depending on the situation. ZenMonitor relies on interval batching and GenStage to help calm the deluge into a throttled stream of :DOWN messages that may take more wall clock time to process but has more predictable scheduler utilization and network consumption. Message Interspersing In the inverse scenario, a single process monitoring a large number of remote processes, a systemic failure of a large number of monitored processes can result in blocking the message queue. This can cause other messages being sent to the process to backup behind the :DOWN messages. Here's what a message queue might look like if 100,000 monitors fired due to node failure. + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | { :DOWN , ref , :process , pid_1 , :nodedown } | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | { :DOWN , ref , :process , pid_2 , :nodedown } | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + ... snip 99 , 996 messages ... + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | { :DOWN , ref , :process , pid_99_999 , :nodedown } | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | { :DOWN , ref , :process , pid_100_000 , :nodedown } | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | :work | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | :work | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | :work | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + ... etc ... The process has to process the 100,000 :DOWN messages before it can get back to doing work, if the processing of a :DOWN message is non-trivial then this could result in the process effectively appearing unresponsive to callers expecting it to do :work . ZenMonitor.Local.Dispatcher provides a configurable batch sweeping system that dispatches a fixed demand_amount of :DOWN messages every demand_interval (See the documentation for ZenMonitor.Local.Dispatcher for configuration and defaults). Using ZenMonitor the message queue would look like this. + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | { :DOWN , ref , :process , pid_1 , :nodedown } | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + ... snip 4 , 998 messages ... + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | { :DOWN , ref , :process , pid_5000 , :nodedown } | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | :work | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + ... snip messages during demand_interval ... + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | :work | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | { :DOWN , ref , :process , pid_5001 , :nodedown } | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + ... snip 4 , 998 messages ... + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | { :DOWN , ref , :process , pid_10_000 , :nodedown } | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | :work | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + ... snip messages during demand_interval ... + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | :work | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + ... etc ... This means that the process can continue processing work messages while working through more manageable batches of :DOWN messages, this improves the effective responsiveness of the process. Message Truncation :DOWN messages include a reason field that can include large stack traces and GenServer state dumps. Large reason s generally don't pose an issue, but in a scenario where thousands of processes are monitoring a process that generates a large reason the cumulative effect of duplicating the large reason to each monitoring process can consume all available memory on a node. When a :DOWN message is received for dispatch to remote subscribers, the first step is to truncate the message using ZenMonitor.Truncator , see the module documentation for more information about how truncation is performed and what configuration options are supported. This prevents the scenario where a single process with a large stack trace or large state gets amplified on the receiving node and consumes an large amount of memory.","ref":"readme.html#why","title":"ZenMonitor - Why?","type":"extras"},{"doc":"ZenMonitor is constructed of two cooperating systems, the Local ZenMonitor System and the Proxy ZenMonitor System . When a process wishes to monitor a remote process, it should inform the Local ZenMonitor System which will efficiently dispatch the monitoring request to the remote node's Proxy ZenMonitor System . Local ZenMonitor System The Local ZenMonitor System is composed of a few processes, these are managed by the ZenMonitor.Local.Supervisor. The processes that comprise the Local ZenMonitor System are described in detail in the following section. ZenMonitor.Local ZenMonitor.Local is responsible for accepting monitoring and demonitoring requests from local processes. It will send these requests to the Connector processes for efficient transmission to the responsible ZenMonitor.Proxy processes. When a monitored process dies, the ZenMonitor.Proxy will send this information in a summary message to the ZenMonitor.Local.Connector process which will use the send down_dispatches to ZenMonitor.Local for eventual delivery by the ZenMonitor.Local.Dispatcher. ZenMonitor.Local is also responsible for monitoring the local interested process and performing clean-up if the local interested process crashes for any reason, this prevents the Local ZenMonitor System from leaking memory. ZenMonitor.Local.Tables This is a simple process that is responsible for owning shared ETS tables used by various parts of the Local ZenMonitor System. It maintains two tables, ZenMonitor.Local.Tables.Nodes and ZenMonitor.Local.Tables.References these tables are public and are normally written to and read from by the ZenMonitor.Local and ZenMonitor.Local.Connector processes. ZenMonitor.Local.Connector ZenMonitor.Local.Connector is responsible for batching monitoring requests into summary requests for the remote ZenMonitor.Proxy. The Connector handles the actual distribution connection to the remote ZenMonitor.Proxy including dealing with incompatible and down nodes. When processes go down on the remote node, the Proxy ZenMonitor System will report summaries of these down processes to the corresponding ZenMonitor.Local.Connector. There will be one ZenMonitor.Local.Connector per remote node with monitored processes. ZenMonitor.Local.Dispatcher When a remote node or remote processes fail, messages will be enqueued for delivery. The ZenMonitor.Local.Dispatcher is responsible for processing these enqueued messages at a steady and controlled rate. Proxy ZenMonitor System The Proxy ZenMonitor System is composed of a few processes, these are managed by the ZenMonitor.Proxy.Supervisor . The processes that comprise the Proxy ZenMonitor System are described in detail in the following section. ZenMonitor.Proxy ZenMonitor.Proxy is responsible for handling subscription requests from the Local ZenMonitor System and for maintaining the ERTS Process Monitors on the processes local to the remote node. ZenMonitor.Proxy is designed to be efficient with local monitors and will guarantee that for any local process there is, at most, one ERTS monitor no matter the number remote processes and remote nodes are interested in monitoring that process. When a local process goes down ZenMonitor.Proxy will enqueue a new death certificate to the ZenMonitor.Proxy.Batcher processes that correspond to the interested remotes. ZenMonitor.Proxy.Tables This is a simple process that is responsible for owning shared ETS tables used by various parts of the Proxy ZenMonitor System . It maintains a single table, ZenMonitor.Proxy.Tables.Subscribers . This table is used by both the ZenMonitor.Proxy and ZenMonitor.Proxy.Batcher processes. ZenMonitor.Proxy.Batcher This process has two primary responsibilities, collecting and summarizing death certificates and monitoring the remote process. For every remote ZenMonitor.Local.Connector that is interested in monitoring processes on this node, a corresponding ZenMonitor.Proxy.Batcher is spawned that will collect and ultimately deliver death certificates. The ZenMonitor.Proxy.Batcher will also monitor the remote ZenMonitor.Local.Connector and clean up after it if it goes down for any reason.","ref":"readme.html#design","title":"ZenMonitor - Design","type":"extras"},{"doc":"ZenMonitor ships with an Application, ZenMonitor.Application which will start the overall supervisor, ZenMonitor.Supervisor . This creates a supervision tree as outlined below. -- -- -- -- -- -- -- -- -- -- -- -- - + -- -- | ZenMonitor.Local.Tables | | -- -- -- -- -- -- -- -- -- -- -- -- - | | -- -- -- -- -- -- -- -- -- + -- -- | ZenMontior.Local | -- -- -- -- -- -- -- -- -- -- -- -- -- -- - | -- -- -- -- -- -- -- -- -- + -- -- | ZenMonitor.Local.Supervisor | -- -- | | -- -- -- -- -- -- -- -- -- -- -- -- -- -- - | -- -- -- -- -- -- - -- -- -- -- -- -- -- -- -- -- -- -- -- -- | + -- -- | GenRegistry | -- N -- | ZenMonitor.Local.Connector | | | -- -- -- -- -- -- - -- -- -- -- -- -- -- -- -- -- -- -- -- -- | | | | -- -- -- -- -- -- -- -- -- -- -- -- -- -- - | + -- -- | ZenMonitor.Local.Dispatcher | | -- -- -- -- -- -- -- -- -- -- -- -- -- -- - -- -- -- -- -- -- -- -- -- -- -- - | | ZenMonitor.Supervisor | -- -- | -- -- -- -- -- -- -- -- -- -- -- - | -- -- -- -- -- -- -- -- -- -- -- -- - | + -- -- | ZenMonitor.Proxy.Tables | | | -- -- -- -- -- -- -- -- -- -- -- -- - | | | -- -- -- -- -- -- -- -- -- -- -- -- -- -- - | -- -- -- -- -- -- -- -- -- + -- -- | ZenMonitor.Proxy.Supervisor | -- -- + -- -- | ZenMonitor.Proxy | -- -- -- -- -- -- -- -- -- -- -- -- -- -- - | -- -- -- -- -- -- -- -- -- | | -- -- -- -- -- -- - -- -- -- -- -- -- -- -- -- -- -- -- -- + -- -- | GenRegistry | -- M -- | ZenMonitor.Proxy.Batcher | -- -- -- -- -- -- - -- -- -- -- -- -- -- -- -- -- -- -- --","ref":"readme.html#running-a-compatible-node","title":"ZenMonitor - Running a Compatible Node","type":"extras"}]